/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.client.client.ui.uinfo;

import java.util.List;

import org.dive4elements.river.client.client.ui.DatacageWidget;
import org.dive4elements.river.client.client.ui.DatacageWidgetData;
import org.dive4elements.river.client.shared.model.DataList;
import org.dive4elements.river.client.shared.model.User;

import com.smartgwt.client.util.SC;
import com.smartgwt.client.widgets.Button;
import com.smartgwt.client.widgets.Canvas;
import com.smartgwt.client.widgets.events.ClickEvent;
import com.smartgwt.client.widgets.events.ClickHandler;
import com.smartgwt.client.widgets.layout.Layout;
import com.smartgwt.client.widgets.layout.VLayout;
import com.smartgwt.client.widgets.tree.TreeNode;

public class VegetationzonesTablePanel extends AbstractVegZonesTablePanel {

    private static final long serialVersionUID = 1L;
    private final User user;

    public VegetationzonesTablePanel(final User user) {
        super();
        this.user = user;
    }

    @Override
    public void createWidget(final Layout root, final DataList data) {
        createTable(root, data, "420", false);
    }

    @Override
    protected Canvas createHelper(final DataList dataList) {

        final DatacageWidgetData data = new DatacageWidgetData(this.artifact, this.user, "uinfo.inundation_duration.vegZoneSelect", "load-system:true", false);

        final DatacageWidget datacage = new DatacageWidget(data);

        final Button plusBtn = new Button(this.MSG.uinfo_inundation_duration_set_vegetation_zone());
        plusBtn.setAutoFit(true);
        plusBtn.addClickHandler(new ClickHandler() {
            @Override
            public void onClick(final ClickEvent event) {
                final List<TreeNode> selection = datacage.getPlainSelection();
                if (selection == null || selection.isEmpty()) {
                    SC.say(VegetationzonesTablePanel.this.MSG.warning());
                    return;
                }
                final String data = selection.get(0).getAttribute("data");
                createTableFromDataStr(data);
                updateValidationMsgLabel();
            }
        });

        final VLayout helperLayout = new VLayout();
        helperLayout.addMember(datacage);
        helperLayout.addMember(plusBtn);

        return helperLayout;
    }
}
